; MasterLink, Version 1.0, 12-NOV-82 Copyright (C) 1982, 1983 by Wizard of OsZ
 
MACLIB	ML	; inbuf, cmdline, inlncomp, mfaccess, dirlist routines.

; assembly origin and program beginning

	ORG	100H

; a few starting definitions

TRUE	EQU	-1	; define true
FALSE	EQU	NOT TRUE; define false
;
DBUFSI	EQ	1	; buffe siz i kbytes
MH	EQ		; cp cloc spee i mhz

; terminal equates
 
CLS	EQU	'Z'-40H	; clears screen and homes cursor
ETEOL	EQU	'R'	; esc followed by R = 'delete line at cursor position'

; modem equates

mdctlp	equ	02a00h	; serial control port
mddatp	equ	02a01h	; serial data port
baud	equ	0efc1h	; storage for baud/mode

; initialization values shown are for 8 data bits, one stop bit, no parity

initc1	equ	057h	; 1st init char to 6850 ACIA
initc2	equ	055h	; 2nd (1200 baud, 056h = 300 baud)
;
frmer	equ	010h	; framing error mask
oruner	equ	020h	; overrun error mask
parer	equ	040h	; parity error mask
;
modsndb	equ	002h	; bit to test for send
modsndr	equ	002h	; value when ready
modrcvb	equ	001h	; bit to test for receive
modrcvr	equ	001h	; value when ready

BRKMSK	 EQU	060H	; mask to set break level
ERRCDMSK EQU	070H	; mask for all bits except error codes
 
; modem control command words

CLEAR	EQU	3FH	; idle mode
MAKEM	EQU	1	; tele line make (off-hook)
BRKM	EQU	0	; tele line on hook (break during dialing)
DTMSK	EQU	1	; dial tone mask
RBLMT	EQU	70	; # of sec*10 to wait till no ring heard msg given
RBWAIT	EQU	50	; # of sec*10 delay before re-dialing number
TMPUL	EQU	80H	; timer pulses mask bit
TRATE	EQU	250	; value for 0.1 second

; other equates

WAITCTS	EQU	160	; (255 max) seconds x 5 to wait for..
			; ..computer tone after Mark VII auto-dial..
			; ..function (160 = delay of 32 seconds).
ERRLIM	EQU	10	; number of retry-times on..
			; ..send/receive error before quitting.
BRKCHR	EQU	'@'-40H	;  ^@ = transmit "break" with Mark VII
EXITCHR	EQU	'E'-40H	;  ^e = exit without disconnect
DISCCHR	EQU	'D'-40H	;  ^d = disconnect
TRANCHR	EQU	'T'-40H	;  ^t = transfer character
CAN	EQU	'X'-40H	;  ^x = cancel dialing/send/receive
EOFCHAR	EQU	'Z'-40H	;  ^z = end of file
SAVECHR	EQU	'Y'-40H	;  ^y = save toggle
XOFF	EQU	'S'-40H	;  ^s = xoff character
XON	EQU	'Q'-40H	;  ^q = xon character
EXTCHR	EQU	'^'-40H	;  ^^ = send nxt chr
SOH	EQU	1	; start of header
EOT	EQU	4	; end of text
ACK	EQU	6	; acknowledge
BELL	EQU	7	; bell character
HT	EQU	9	; tab character
LF	EQU	10	; linefeed
CR	EQU	13	; carriage return
ESC	EQU	27	; escape character
NAK	EQU	15H	; not acknowledge
CRC	EQU	'C'	; used to request crc instead of checksum
BDNMCH	EQU	75H	; bad name match
OKNMCH	EQU	ACK	; okay name match

; bdos equates

RDCON	EQU	1	; console input with wait and echo
WRCON	EQU	2	; byte out to console
BDOS	EQU	5
PRINT	EQU	9	; string out to console, unto "$".
OPEN	EQU	15
CLOSE	EQU	16
SRCHF	EQU	17
SRCHN	EQU	18
ERASE	EQU	19
READ	EQU	20
WRITE	EQU	21
MAKE	EQU	22
REN	EQU	23
INQDISK	EQU	25	; get default drive
SETDMA	EQU	26
COMPSZ	EQU	35	; compute file size
FCB	EQU	5CH	; cp/m default fcb
FCBEXT	EQU	FCB+12	; extent
FCB2	EQU	6CH	; second default fcb
FCBRNO	EQU	FCB+32	; sector (record) number


	JMP	BEGIN

; phone number table for dialing from library of numbers
; stored in these db's at assembly-time.  each db must be
; 34 characters long for correct operation.  last db must
; be db 0.  up to 26 numbers are allowed.  "r" as a last
; character in line indicates an automatic ringback call,
; i.e., ring once, hang up, ring back and let ring to "time
; -out," or connection.  don't use tabs in the db fields.

NUMBLIB	DB	'A                                 '
	DB	'B                                 '
	DB	'C                                 '
	DB	'D                                 '
	DB	'E                                 '
	DB	'F                                 '
	DB	'G                                 '
	DB	'H                                 '
	DB	'I                                 '
	DB	'J                                 '
	DB	'K                                 '
	DB	'L                                 '
	DB	'M                                 '
	DB	'N                                 '
	DB	'O                                 '
	DB	'P                                 '
	DB	'Q Keith Petersen*....313-759-6569R'
	DB	'R                                 '
	DB	'S                                 '
	DB	'T Sacto RCP/M.........916-423-3389'
	DB	'U                                 '
	DB	'V Pasadena RCP/M......213-799-1632'
	DB	'W CP/M-NET(TM)........805-527-9321'
	DB	'X                                 '
	DB	'Y Ward/Randy CBBS*....312-545-8086'
	DB	'Z                                 ',0	; end

BAKUPBYTE	DB  TRUE	; true=make .bak file
XPRFLG		DB  FALSE	; false=print menu 1st time thru only
PULSERATE	DB  125		; 125 for 20pps dialing, 250=10pps
SAVCCP		DB  TRUE	; true=do not overwrite ccp

IN$BAUDRP	LDA	BAUD 
		RET		; get baud/mode

OUT$BAUDRP	STA	BAUD
		RET		; put baud/mode

BEGIN	LXI	H,0
	DAD	SP	; get cp/m's stack (add sp to hl)
	SHLD	STACK	; save it (store hl at stack)
	LXI	SP,STACK; start local stack (put stack into sp)
	CALL	BEGIN1
	DB	CLS	; clear crt screen
	DB '            - MasterLink, Version 1.0 - ',CR,LF
	DB	ESC,')'	; dim
	DB '   Signalman Mark IV Modem and Osborne I Computer',CR,LF
	DB	ESC,'('	; bright
	DB '     Copyright (C) 1982, 1983 by Wizard of OsZ',CR,LF,LF
	DB	ESC,')'	; dim
	DB '          MasterLink (TM), Wizard of OsZ',CR,LF
	DB '      Signalman (TM), Anchor Automation, Inc.',CR,LF
	DB '            CP/M (TM), Digital Research',CR,LF
	DB '   Osborne I (TM), Osborne Computer Corporation',CR,LF
	DB	ESC,'('	; bright
	DB	CR,LF,'$'
BEGIN1	POP	D	; get address of above logon message
	MVI	C,PRINT
	CALL	BDOS

; move buffers and modem I/O above shadow prom area

dest	equ	04000h	; destination of I/O is above shadow prom

	lxi	b,pend-start+1	; number of bytes to move
	lxi	h,dest+pend-start+1	; end of moved I/O
	lxi	d,source+pend-start	; end of source code of I/O
mvlp:	ldax	d	; get byte
	dcx	h	; de-bump pointers
	dcx	d
	dcx	b
	mov	m,a	; move to new location
	mov	a,b	; check for move completion
	ora	c
	jnz	mvlp	; if not, move some more

; initializes the modem

	mvi	a,initc1;get 1st init char
	call	outctl	; output it
	mvi	a,initc2;get 2nd init char
	call	outctl	; output it
	STA	UARTCTL

	MVI	D,6*MHZ	;  6 second double-loop delay..(1=one sec)
DELAY1	LXI	B,41667	; ..for reading logon msg before main..
DELAY2	DCX	B      	; ..menu automatically appears 1st time.
	MOV	A,B	; 'm' causes menu reappearance in cmd mode
	ORA	C	;  (dcx-inner loop=1/4 sec for 4 mhz cpu)
	JNZ	DELAY2
	DCR	D
	JNZ	DELAY1
	CALL	INITADR	; initialize addresses and modem
START3	CALL	PROCOPT	; process control options
START2	XRA	A
	STA	XPRFLG	; show menu first time thru
	JMP	MENU

RESTART	LDA	OPTION	; get main (primary) option
	CPI	'C'	; call (dial) function?
	JZ	DIALPL	; yes, go for it!
S1	CPI	' '	; no option spec'd?
	JZ	MENU	; true, go menu
	CPI	'M'	; menu asked for?
	JZ	MENU2	; yes, go menu
	CALL	MOVEFCB
	XRA	A
	STA	NFILFLG
	CALL	INDATA	; gobble up garbage..
	CALL	INDATA	; ..characters on line.
	LDA	OPTION	; process main (primary) option
	CPI	'E'	; echo mode?
	JZ	TRMECHO	; yes
	CPI	'T'	; terminal mode?
	JZ	DSKSAVE	; yes
	CPI	'S'	; send a file?
	JZ	SENDFIL	; yes
	CPI	'R'	; receive a file?
	JZ	RCVFIL	; yes
	CPI	'D'	; disconnect?
	JZ	DISCON1	; yes, disconnect & go menu
	JMP	MENU	; no option spec'd, go menu

; terminal routine allowing memory save

DSKSAVE	LDA	NFILFLG	; no file flag
	CPI	TRUE	; true = normal terminal mode without save
	JZ	TERM	; yes
	LDA	FCB+1	; first char of filename
	CPI	' '	; file spec'd
	JNZ	GOODNM	; yes, good name
	MVI	A,TRUE
	STA	NFILFLG	
	CMA
	STA	ALERTFG
	STA	SAVEFLG	
	JMP	TERM	

; alert announces file memory save established

ALERT	LDA	ALERTFG
	CPI	TRUE
	JNZ	MENU	; no-save, restore options, show prompt.
	CALL	ILPRT
	DB	CR,LF,'WRT saves file, RET>urns and continues '
	DB	'save.  T, E, S, R, or DEL>etes file.',CR,LF,0
	JMP	MENU1	; options not changed, cmd prompt shows.

; main terminal mode with file-save and -transfer capability

GOODNM	CALL	ERASFIL	; see if file already exists.  erase?
	CALL	MOVE2
	LXI	D,FCB3
	MVI	C,MAKE
	CALL	BDOS
	LXI	D,FCB3
	MVI	C,OPEN
	CALL	BDOS
	LXI	H,BOTTRAM
	SHLD	HLSAVE
	XRA	A
	STA	NFILFLG
TERM	CALL	STAT	; keypress?
	JZ	TERML	; no, check line
	CALL	KEYIN	; get char from kbd
	MOV	B,A	; save
	LDA	EXACFL
	ORA	A	; exact?
	MVI	A,0
	STA	EXACFL	; clr for next time
	MOV	A,B	; restore
	JNZ	NOTOG	; no-save toggle
	CPI	EXITCHR	;  ^e?  test for reenter command mode
	JZ	ALERT	; see if save memory file is wanted
	CPI	DISCCHR	;  ^d?  test for disconnect and reenter cm
	JZ	DISCON1	; yes, disconnect, then to alert return
	CPI	EXTCHR	;  ^^?
	JZ	EXTFLG	; yes, set flag for nxt char
	CPI	TRANCHR	;  ^t?  test for transfer file request
	CZ	TRANSFER	; send-a-file (blind send)
	JZ	TERM	; loop
	CPI	BRKCHR	; break?
	JZ	BREAK
	CPI	SAVECHR	;  ^y ("colon-save")
	JNZ	NOTOG
	LDA	NFILFLG	; save not allowed, if no filename
	CPI	TRUE
	JZ	TERML
	MVI	A,TRUE
	STA	ALERTFG ; set 1st time thru to alert for a save
	LDA	SAVEFLG
	CMA
	STA	SAVEFLG	; toggle
	JMP	TERML

EXTFLG	MVI	A,TRUE
	STA	EXACFL
	JMP	TERML

NOTOG	CALL	OUTDATA

; character input from telephone line

TERML	CALL	INCTL
	ANI	MODRCVB
	CPI	MODRCVR
	JNZ	TERM
	CALL	INDATA
	ANI	7FH	; strip parity
	JZ	TERM		
	CALL	TYPE
	PUSH	PSW
	LDA	SAVEFLG
	CPI	FALSE
	JZ	NOSAVE
	POP	PSW
	MOV	M,A
	INX	H	; menu command destroys hl-reg.  get..
	SHLD	HLSAVE	; ..hl when entering via 'ret' cmd.
COLON	CPI	LF
	JNZ	NOCOLON	; ..type ":" after each line feed..
	MVI	A,':'	; ..when memory save active.
	CALL	TYPE
NOCOLON	LDA	SAVCCP
	ORA	A
	JZ	SUB1
	LDA	7	; check to see if..
	SBI	8	; ..page below ccp..
	JMP	SUB1A

SUB1	LDA	7
SUB1A	DCR	A	; ..or bdos has been..
	CMP	H	; ..reached and disksave is needed.
	CZ	INTDSKSV
	JMP	TERM

NOSAVE	POP	PSW
	JMP	TERM

SAVEFLG		DB FALSE
LASTBYT1	DB 0
LASTBYT2	DB 0

; save-file to disk

INTDSKSV
	MVI	A,XOFF	; send a ctrl-s to stop remote..
	CALL	OUTDATA ; ..computer output.  d is the..
	MVI	D,0	; ..is the buffer count.  get..
	CALL	INMODEM	; ..last bytes sent after ctrl-s.
	STA	LASTBYT1; add more calls to inmodem and..
	CALL	INMODEM	; ..sta lastbyt# if bytes are..
	STA	LASTBYT2; ..being lost when full memory.
	PUSH	D
	CALL	NUMREC1
	CALL	WRTDSK	; write the records
	POP	D
	LXI	H,BOTTRAM
	INR	D
	DCR	D	; test buffer count for zero
	JZ	CTRLQ
	LDA	LASTBYT1; get the last bytes that were..
	MOV	M,A	; ..saved and put them in..
	INX	H	; ..bottram.
	CALL	TYPE
	DCR	D
	JZ	CTRLQ
	LDA	LASTBYT2
	MOV	M,A
	INX	H
	CALL	TYPE
CTRLQ	MVI	A,XON	; send start character (ctrl-q)..
	CALL	OUTDATA	; ..to remote computer.
	RET

BREAK	PUSH	D	; save it
	LXI	D,0	; zero it
	LDA	MODCTLB	; get the last modem control byte
	ORI	BRKMSK	; set the transmit break bit low (active)
	CALL	OUTCTL	; send it to the modem
	LXI	B,225*MHZ	; break delay counter
BRK1	CALL	TIMERL
	JZ	BRK2	; if time is up reset break
	CPI	0	; check for nulls
	JZ	BRK1	; don't process them
	ANI	7FH	; strip parity
	CALL	TYPE
	PUSH	PSW
	LDA	SAVEFLG
	CPI	FALSE
	JZ	NOSAVEB
	POP	PSW
	MOV	M,A
	INX	H
	SHLD	HLSAVE	; get hl when entering via 'ret' cmd
COLONB	CPI	LF
	JNZ	BRK1	; ..type ":" after each line feed..
	MVI	A,':'	; ..when memory save active.
	CALL	TYPE
	JMP	BRK1

NOSAVEB POP	PSW	; restore it
	JMP	BRK1

BRK2	LDA	MODCTLB	; get modem control byte
	CALL	OUTCTL
	POP	D
	LHLD	HLSAVE	; last address written if data being saved
	LDA	SAVCCP
	ORA	A
	JZ	SUB2
	LDA	7	; check to see if..
	SBI	8	; ..page below ccp..
	JMP	SUB2A

SUB2	LDA	7
SUB2A	DCR	A	; ..or bdos has been..
	CMP	H	; ..reached and disksave is needed.
	JNZ	TERM	; no problem - go back to normal routine.
	CALL	ILPRT
	DB	CR,LF,'Memory SAVE buffer full',CR,LF,BELL,0
	JMP	TERM

; this subroutine loops until the modem receives a character or
; 100 milliseconds.  if a character is received, a flag is set to
; store the character, a max of two characters. but more may be
; stored if desired (see comment in "intdsksv" above).

INMODEM	LXI	B,625*MHZ	; for 100ms delay
TIMERL	CALL	INCTL
	ANI	MODRCVB
	CPI	MODRCVR
	JZ	GETBYTE
	DCX	B
	MOV	A,B
	ORA	C
	JNZ	TIMERL
	RET

GETBYTE	CALL	INDATA
	INR	D
	RET

NUMRECS	MVI	M,EOFCHAR
	INX	H
	LXI	D,127
	DAD	D
NUMREC1	LXI	D,-(BOTTRAM)
	DAD	D
	MOV	A,L	; divide hl by 128..
	ORA	A
	RAL	; ..to get the..
	MOV	L,H	; ..number of sectors
	MVI	H,0
	PUSH	PSW
	DAD	H
	POP	PSW
	XRA     A
	ADC	L
	MOV	L,A	; returns with number of..
	RET		; ..128 byte records in hl.

WRTDSK	LXI	D,BOTTRAM
NEXTWRT	MVI	C,SETDMA
	CALL	BDOSRET
	PUSH	D
	LXI	D,FCB3
	MVI	C,WRITE
	CALL	BDOSRET
	POP	D
	XCHG
	PUSH	D
	LXI	D,128
	DAD	D
	POP	D
	XCHG
	MOV	A,H	; these three lines return without..
	ORA	L	; ..writing whole disk if wrt is used..
	RZ		; ..with 0k file.
	DCX	H
	MOV	A,H
	ORA	L
	JN	NEXTWRT
	RET

CLOSE3	LXI	D,FCB3
	MVI	C,CLOSE
	CALL	BDOS
	RET

BDOSRET	PUSH	B
	PUSH	D
	PUSH	H
	PUSH	PSW
	CALL	BDOS
	POP	PSW
	POP	H
	POP	D
	POP	B
	RET

MOVE2	LXI	H,FCB3
	CALL	INITFCBS
	LXI	H,FCB
	LXI	D,FCB3
	MVI	B,12
	CALL	MOVE
	RET

; file transfer subroutine -- called with ctrl-t from terminal
; routine.  transfer cancelled while sending by using ctrl-x.
; choice of straight or protocol send into receiving line editor.

TRANSFER
	PUSH	H
	PUSH	D
	PUSH	B
	PUSH	PSW
	LXI	H,FCB4
	CALL	INITFCBS; initializes fcbs pointed..
	LXI	H,FCB+16; ..to by hl-reg.
	CALL	INITFCBS
GET	CALL	GETNAME
	LDA	CMDBUF+2; was file entered?
	CPI	' '
	JZ	TRANSL2
	CALL	MOVE4
	CALL	OPEN4
	CPI	TRUE	; ret 0ffh means no file (fall to transl1)
	JNZ	CONTIN0
TRANSL1 CALL	ILPRT
	DB	'++ FILE NOT FOUND ++',CR,LF,LF,BELL,0
TRANSL2 CALL	ILPRT
	DB	'R>eturn to Terminal Mode or A>gain to reenter name: ',0
	CALL	KEYIN
	CALL	UCASE
	CALL	TYPE	; echo response
	CALL	CRLF
	CPI	'A'
	JZ	GET
	CPI	'R'
	JZ	RETURN
	JMP	TRANSL2

CONTIN0	CALL	ILPRT
	DB	'S>equential uninterupted or P>rompted '
	DB	'line-edito transfer ',0
	CALL	KEYIN
	CALL	UCASE
	CALL	TYPE
	CALL	CRLF
	CPI	'S'
	JZ	CONTIN
	CPI	'P'
	JZ	CONTINE
	JMP	CONTIN0

CONTINE	XRA	A	; zero line-editor flag
	STA	LNEDFLG
CONTIN	LXI	D,80H	; away we go!
	MVI	C,SETDMA
	CALL	BDOS
READMR	CALL	READ80
	CPI	1	; end of file
	JZ	RETURNS
	CPI	2	; bad read
	JZ	RETURNU
	CALL	SEND80C
	CPI	EOFCHAR	; end of file (omit if object..
	JZ	RETURNS	; ..code is to be sent)
	CPI	CAN	;  (^x) cancellation?
	JZ	TRANCAN
	JMP	READMR	; loop till eof or ctrl-x

RETURNS	CALL	ILPRT
	DB	CR,LF,'++ FILE TRANSFER COMPLETED ++',CR,LF,BELL,0
	JMP	RETURN

RETURNU	CALL	ILPRT
	DB	CR,LF,'++ FILE TRANSFER UNSUCCESSFUL ++',CR,LF,BELL,0
	JMP	RETURN

TRANCAN	CALL	ILPRT
	DB	CR,LF,'++ TRANSFER CANCELLED ++',CR,LF,BELL,0
RETURN	MVI	A,TRUE	; sequential transfer default condition
	STA	LNEDFLG
	POP	PSW
	POP	B
	POP	D
	POP	H
	RET		; to term2 then loop thru term

INITFCBS		; entry at +2 will leave..
	MVI	M,0	; ..drive no. intact.
	INX	H	; will initialize an fcb..
	MVI	B,11	; ..pointed to by hl-reg. fills 1st pos
LOOP10	MVI	M,' '	; ..with 0, next 11 with..
	INX	H	; .. blanks, and last..
	DCR	B	; ..21 with nulls.
	JNZ	LOOP10
	MVI	B,21
LOOP11	MVI	M,0
	INX	H
	DCR	B
	JNZ	LOOP11
	RET

GETNAME CALL	ILPRT
	DB	CR,LF,'Enter FILENAME to transfer '
	DB	'then press <RETURN> to continue: ',0
	LXI	D,CMDBUF
	CALL	INBUFF	; from macro in ml.lib
	CALL	CRLF
	RET

MOVE4	LXI	D,CMDBUF
	LXI	H,FCB4
	CALL	CPMLINE	; from macro in ml.lib
	RET

OPEN4	LXI	D,FCB4
	MVI	C,OPEN
	CALL	BDOS
	RET

READ80	LXI	D,FCB4
	MVI	C,READ	; read 128 bytes
	CALL	BDOS
	RET

SEND80C	MVI	B,80H	; send 128 bytes
	LXI	H,80H	; points to cp/m cmdbuff
SENDCH1	LDA	LNEDFLG	; is it prompted mode?
	ORA	A
	JZ	EDIT	; yes
	MOV	A,M	; no, straight send mode.
	CALL	MODOUT
	CPI	EOFCHAR
	RZ		; to readmr for finish
PROMPT2	CALL	STAT	; test to see if cancellation requested
	JZ	SKIP12
	CALL	KEYIN
	CPI	CAN	;  (^x) 
	RZ		; to readmr for cancel and exit
SKIP12	INX	H	; new character to send pointed to by..
	DCR	B	; ..bumping hl-reg counter forward.
	JNZ	SENDCH1
	RET		; to eofchar in readmr for 128 characters

EDIT	MOV	A,M	; char pointed to by reg-hl into reg-a
	CPI	LF	; see if end of send-text line-feed
	JZ	PROMPT0	; yes, get delay, else..
	CALL	MODOUT	; ..send chararcter over wireline.
	CPI	EOFCHAR
	RZ
	PUSH	B
	LXI	B,4000*MHZ	; delay between send-char..
CLOOP	DCX	B	  	; ..slows transmission.
	MOV	A,B
	ORA	C
	JNZ	CLOOP
	POP	B
	JMP	PROMPT2

PROMPT0	CALL	MODOUT
	PUSH	B
	PUSH D
	MVI	D,12*MHZ; double loop delay for bbs prompt..
TLOOP1	LXI	B,1000H	; ..waiting time (12=3/4 sec, 16=1sec).
TLOOP2	DCR	C
	JNZ	TLOOP2
	DCR	B
	JNZ	TLOOP2
	DCR	D
	JNZ	TLOOP1
	POP	D
	POP B
	JMP	PROMPT2

MODOUT	PUSH	PSW
MODOUTL	CALL	INCTL
	ANI	MODSNDB
	CPI	MODSNDR
	JNZ	MODOUTL
	POP	PSW
	CALL	OUTDATA
	CPI	EOFCHAR	; don't send to terminal
	RZ
	CALL	TYPE
	RET

; terminal echo mode (resemble a computer)

TRMECHO	CALL	INCTL
	ANI	MODRCVB
	CPI	MODRCVR
	JZ	LINECHR
	CALL	STAT
	JZ	TRMECHO
	CALL	KEYIN
	CPI	EXITCHR
	JZ	MENU
	CALL	OUTDATA
	CALL	TYPE
	JMP	TRMECHO

LINECHR	CALL	INDATA
	CALL	OUTDATA
	CALL	TYPE
	JMP	TRMECHO

; send a cp/m file

SENDFIL	LDA	BATCHFLG	; check if multiple file..
	ORA	A	; ..mode is set.
	JNZ	SENDC1
	MVI	A,TRUE	; indicate batch send
	STA	SENDFLG
	LDA	FSTFLG	; if first time thru..
	ORA	A	; ..scan the command line..
	CNZ	TNMBUF	; ..for multiple names.
	CALL	SENDFN	; sends file name to receiver
	JNC	SENDC2	; carry set means no more files.
	MVI	A,'B'	; stop batch..
	STA	BATCHFLG; ..mode option.
	MVI	A,EOT	; final xfer end
	CALL	SEND
	JMP	DONE

SENDC1	LDA	FCB+1
	CPI	' '
	JZ	BLKFILE
SENDC2	CALL	CNREC	; get number of records
	CALL	OPENFIL
	MVI	E,80	; waiting time-out
	CALL	WAITNAK
SENDLP	CALL	RDSECT
	JC	SENDEOF
	CALL	INCRSNO
	MVI	A,1
	STA	ERRCT
SENDRPT	CALL	SENDHDR
	CALL	SENDSEC
	LDA	CRCFLG
	ORA	A
	CZ	SENDCRC
	CNZ	SENDCKS
	CALL	GETACK
	JC	SENDRPT
	JMP	SENDLP

SENDEOF	MVI	A,EOT
	CALL	SEND
	CALL	GETACK
	JC	SENDEOF
	JMP	DONE

; receive a cp/m file

RCVFIL	XRA	A	; default to crc mode
	STA	CRCFLG
RCVFIL1	LDA	BATCHFLG; check if mult-file mode is set
	ORA	A
	JNZ	RCVC1
	XRA	A 	; flag where to return..
	STA	SENDFLG	; ..for next file trans.
	CALL	GETFN	; get the file name.
	JNC	RCVC2	; carry set means no more files.
	MVI	A,'B'	; stop batch..
	STA	BATCHFLG; ..mode option.
	JMP	DONE

RCVC1	LDA	FCB+1	; make sure file is named
	CPI	' '
	JZ	BLKFILE
	JMP	RCVC3

RCVC2	CALL	MAKBAK	; make .bak file
	CALL	CKBAKUP
RCVC3	CALL	ERASFIL
	CALL	MAKEFIL
	LDA	BATCHFLG
	ORA	A	; don't print msg if..
	JNZ	RCVC4	; ..in multi and quiet.
	LDA	QFLG
	ORA	A
	JZ	RCVFST
RCVC4	CALL	ILPRT
	DB	CR,LF,'Ready to Receive -- file open',CR,LF,0
RCVFST	LDA	CRCFLG
	ORA	A
	MVI	A,NAK
	JNZ	RCVFIL2
	MVI	A,CRC
RCVFIL2	CALL	SEND
	LDA	CRCFLG
	ORA	A
	JNZ	RCVNAKM	; if in crc mode..
	CALL	ILPRT	; ..then say so..
	DB	'CRC in effect',CR,LF,0
	JMP	RCVLP

RCVNAKM	CALL	ILPRT	; ..else say checksum mode.
	DB	'CHECKSUM in effect',CR,LF,0
RCVLP	CALL	RCVSECT
	JC	RCVEOT
	CALL	WRSECT
	CALL	INCRSNO
	CALL	SENDACK
	JMP	RCVLP

RCVEOT	CALL	WRBLOCK
	CALL	SENDACK
	CALL	CLOSFIL
	JMP	DONE
	
; a few subroutines

SENDFN	LDA	QFLG
	ORA	A
	JZ	SWNAK
	CALL	ILPRT
	DB	'Awaiting name-NAK',CR,LF,0
SWNAK	MVI	E,80
	CALL	WAITNLP
	MVI	A,ACK	; got nak, send ack
	CALL	SEND
	LXI	H,FILECT
	DCR	M
	JM	NOMRNM
	LHLD	NBSAVE	; get file name..
	LXI	D,FCB	; ..in fcb
	MVI	B,12
	CALL	MOVE
	SHLD	NBSAVE
	CALL	SENDNM	; send it
	ORA	A	; clear carry
	RET

NOMRNM	MVI	A,EOT
	CALL	SEND
	STC
	RET

SENDNM	PUSH	H
SENDNM1	MVI	D,11	; count chars in name
	MVI	C,0	; init checksum
	LXI	H,FCB+1	; address name
NAMLPS	MOV	A,M	; send name
	ANI	7FH	; strip high order bit so cp/m 2..
	CALL	SEND	; ..won't send r/o file designation.
	LDA	QFLG	; show name if..
	ORA	A	; ..qflg not set.
	MOV	A,M
	CNZ	TYPE
ACKLP	PUSH	B	; save cksum
	MVI	B,1	; wait for receiver..
	CALL	RECV	; ..to acknowledge..
	POP	B	; ..getting letter.
	JC	SCKSER
	CPI	ACK
	JNZ	ACKLP
	INX	H	; next char
	DCR	D
	JNZ	NAMLPS
	MVI	A,EOFCHAR	; tell receiver end of name
	CALL	SEND
	LDA	QFLG
	ORA	A
	CNZ	CRLF
	MOV	D,C	; save checksum
	MVI	B,1
	CALL	RECV	; get checksum..
	CMP	D	; ..from receiver.
	JZ	NAMEOK
SCKSER	MVI	A,BDNMCH; bad name, tell receiver.
	CALL	SEND
	LDA	QFLG
	ORA	A
	JZ	SKCSER1
	CALL	ILPRT
	DB	'++ CHECKSUM error ++',CR,LF,BELL,0
SKCSER1	MVI	E,80	; do handshaking over
	CALL	WAITNLP	; don't print "awaiting nak" msg
	MVI	A,ACK
	CALL	SEND
	JMP	SENDNM1

NAMEOK	MVI	A,OKNMCH; good name, tell receiver.
	CALL	SEND
	POP	H
	RET	

GETFN	LXI	H,FCB
	CALL	INITFCBS+2	; does not initialize drive
	LDA	QFLG
	ORA	A
	JZ	GNAMELP
	CALL	ILPRT
	DB	'Awaiting FILENAME',CR,LF,0
GNAMELP	CALL	HSNAK
	JC	GNAMELP
	CALL	GETNM	; get the name
	CPI	EOT	; if eot, then no more files
	JZ	NOMRNMG
	ORA	A	; clear carry
	RET

NOMRNMG	STC
	RET

GETNM	PUSH	H
GETNM1	MVI	C,0	; init checksum
	LXI	H,FCB+1
NAMELPG	MVI	B,5
	CALL	RECV	; get char (5-sec wait)
	JNC	GETNM3
	LDA	QFLG
	ORA	A
	JZ	GETNM2
	CALL	ILPRT
	DB	'Time-out receiving FILENAME',CR,LF,0
GETNM2	JMP	GCKSER

GETNM3	CPI	EOT	; if eot, then no more files
	JZ	GNRET
	CPI	EOFCHAR	; got end of name
	JZ	ENDNAME
	MOV	M,A	; put name in fcb
	LDA	QFLG	; type it if no qflg
	ORA	A
	MOV	A,M
	CNZ	TYPE
	PUSH	B	; save cksum
	MVI	A,ACK	; ack getting letter
	CALL	SEND
	POP	B
	INX	H	; get next char
	MOV	A,L	; don't let noise...
	CPI	7FH	; ..cause overflow..
	JZ	GCKSER	; ..into program area.
	JMP	NAMELPG

ENDNAME	LDA	QFLG
	ORA	A
	CNZ	CRLF
	MOV	A,C	; send checksum
	CALL	SEND
	MVI	B,1
	CALL	RECV	; checksum good?
	CPI	OKNMCH	; yes if oknmch sent..
	JZ	GNRET	; ..else do over.
GCKSER	LXI	H,FCB	; clear fcb (except drive)..
	CALL	INITFCBS+2	; ..since it might be damaged..
	LDA	QFLG	; ..by too many chars.
	ORA	A
	JZ	GCKSER1
	CALL	ILPRT
	DB	'++ CHECKSUM error ++',CR,LF,BELL,0
GCKSER1	CALL	HSNAK	; do handshaking over
	JC	GCKSER1
	JMP	GETNM1

GNRET	POP	H
	RET

HSNAK	MVI	A,NAK	; send nak until..
	CALL	SEND	; ..receiving ack.
	CALL	CKABORT	; don't get hung up here
	MVI	B,2	; wait 2 seconds..
	CALL	RECV	; ..in receive.
	CPI	ACK	; if ack, return with..
	RZ		; ..carry clear.
	STC
	RET

TNMBUF	XRA	A	; call from sendfil only once.
	STA	FSTFLG
	STA	FILECT
	CALL	SCAN
	LXI	H,NAMEBUF
	SHLD	NBSAVE	; save addr of 1st name
TNLP1	CALL	TRTOBUF
	LXI	H,FCB
	LXI	D,FCBBUF
	CALL	CPMLINE	; parse name to cp/m format
TNLP2	CALL	MFNAME	; search for names (* format)
	JC	NEXTNM
	LDA	FCB+10	; if cp/m 2 $sys file..
	ANI	80H	; ..don't send
	JNZ	TNLP2
	LHLD	NBSAVE	; get name
	LXI	D,FCB	; move it to fcb
	XCHG
	MVI	B,12
	CALL	MOVE
	XCHG
	SHLD	NBSAVE	; addr of next name
	LXI	H,FILECT	; count files found
	INR	M
	JMP	TNLP2

NEXTNM	LXI	H,NAMECT	; count names found
	DCR	M
	JNZ	TNLP1
	LXI	H,NAMEBUF	; save start of buffer
	SHLD	NBSAVE
	LDA	FILECT
	CPI	65	; no more than 64 transfers
	RC
	MVI	A,64	; only x'fer first 64
	STA	FILECT
	RET

; scans cmdbuf, counts names, and puts "space" after last name

SCAN	PUSH	H
	LXI	H,NAMECT
	MVI	M,0
	LXI	H,CMDBUF+1	; find end of cmd line..
	MOV	C,M	; ..and put space there.
	MVI	B,0
	LXI	H,CMDBUF+2
	DAD	B
	MVI	M,' '
	LXI	H,CMDBUF+1
	MOV	B,M
	INR	B
	INR	B
SCANLP1	INX	H
	DCR	B
	JZ	DNSCAN
	MOV	A,M
	CPI	' '
	JNZ	SCANLP1
SCANLP2	INX	H	; eat extra spaces
	DCR	B
	JZ	DNSCAN
	MOV	A,M
	CPI	' '
	JZ	SCANLP2
	SHLD	BGNMS	; save start of names in cmdbuf
	INR	B
	DCX	H
SCANLP3	INX	H
	DCR	B
	JZ	DNSCAN
	MOV	A,M
	CPI	' '
	JNZ	SCANLP3
	LDA	NAMECT	; counts names
	INR	A
	STA	NAMECT
SCANLP4	INX	H	; eat spaces
	DCR	B
	JZ	DNSCAN
	MOV	A,M
	CPI	' '
	JZ	SCANLP4
	JMP	SCANLP3

DNSCAN	MVI	M,' '	; space after last char
	POP	H
	RET

; places next name in buffer so cpmline may parse it

TRTOBUF	LHLD	BGNMS
	MVI	B,0
	LXI	D,FCBBUF+2
TBLP	MOV	A,M
	CPI	' '
	JZ	TRBFEND
	STAX	D
	INX	H
	INX	D
	INR	B	; count chars in name
	JMP	TBLP

TRBFEND	INX	H
	MOV	A,M	; eat extra spaces
	CPI	' '
	JZ	TRBFEND
	SHLD	BGNMS
	LXI	H,FCBBUF+1	; put # chars before name
	MOV	M,B
	RET

; if file is r/o or sys, it is changed to 'bak'.

MAKBAK	MVI	C,SETDMA
	LXI	D,80H
	CALL	BDOS
	MVI	C,SRCHF	; search for file
	LXI	D,FCB
	CALL	BDOS
	CPI	TRUE
	RZ
	ADD	A
	ADD A	; mult a-reg by..
	ADD	A
	ADD A	; ..32 to find..
	ADD	A	; ..name in dma.
	LXI	H,80H
	ADD	L
	MOV	L,A	; hl points to dir name
	LXI	D,9
	DAD	D	; point to r/o attrib byte
	MOV	A,M
	ANI	80H	; test msb
	JNZ	MKCHG	; if set, make change
	INX	H	; check system attrib byte
	MOV	A,M
	ANI	80H
	RZ		; not $sys or $r/o
	DCX	H
MKCHG	LXI	D,-8
	DAD	D	; point hl to filename + 1
	LXI	D,FCB+1	; move dir name to fcb..
	MVI	B,11	; ..without changing drive.
	CALL	MOVE
	LXI	H,FCB+9	; r/o attrib
	MOV	A,M
	ANI	7FH	; strip r/o attrib
	MOV	M,A
	INX	H	; sys attrib
	MOV	A,M
	ANI	7FH
	MOV	M,A
	LXI	D,FCB
	MVI	C,30	; set new file attributes in dir
	CALL	BDOS

; may be called by ckbakup below.  its return done here.

PLANCHG	LXI	H,FCB	; change name to type "bak"
	LXI	D,FCB2
	MVI	B,9	; move drive and name (not type)
	CALL	MOVE
	LXI	H,75H	; start of type in fcb2
	MVI	M,'B'
	INX	H
	MVI	M,'A'
	INX	H
	MVI	M,'K'
	LXI	D,6CH
	MVI	C,ERASE	; erase any prev backups
	CALL	BDOS
	LXI	H,FCB2	; fcb2 dr field should..
	MVI	M,0	; ..be 0 for rename.
	LXI	D,FCB
	MVI	C,REN	; rename the file
	CALL	BDOS
	RET

CKBAKUP	LDA	BAKUPBYTE
	ORA	A
	RZ
	MVI	C,SRCHF
	LXI	D,FCB
	CALL	BDOS
	INR	A	; 0ffh -> 0 means..
	RZ		; ..file not found.
	JMP	PLANCHG

; multi-file access subroutine - carry is set if no more names can be found

MFNAME	MFACCESS	; a macro in ml.lib

RCVSECT MVI	A,1	; set to one, not zero
	STA	ERRCT
RCVRPT	XRA	A	; zero accum
	STA	ERRCDE	; clear receive error code
	LDA	QFLG
	ORA	A
	JZ	RCVSQ
	CALL	ILPRT
	DB	CR,'Awaiting Data Block # ',0
	PUSH	H	; save it
	LHLD	SECTNO	; get sector number
	INX	H	; bump it
	CALL	DECOUT	; print sector number in decimal
	CALL	ILPRT
	DB	' (', 0
	CALL	DHXOUT	; 16 bit hex conversion & output
	CALL	ILPRT
	DB	'H)',0
	MOV	A,L	; only low byte used by program
	POP	H	; restore it

; if crc is in effect, there is only a 3 second wait for
; the first soh.  if the soh is not received within 3
; seconds, then a nak is sent which tells the sender to use
; checksum checking instead of crc.  this allows automatic
; compatability with versions of xmodem that do not
; implement crc (cyclic redundancy checking).

RCVSQ	LDA	FIRSTME	; first soh...
	ORA	A	; ...been received?
	JZ	RCVSQ2	; yes, go get next soh
	XRA	A	; turn off...
	STA	FIRSTME	; ...first soh recvd switch.
	LDA	CRCFLG	; crc in...
	ORA	A	; ...effect?
	JNZ	RCVSQ2	; no, do long wait for first soh.
	MVI	B,7	; wait for up to 7 seconds
	CALL	RECV	; get a character from modem
	JNC	RCVSQ3	; got a char, go see if soh.
	CALL	ILPRT
	DB	CR,LF,'CHECKSUM mode',CR,LF,0
	MVI	A,'C'	; turn off...
	STA	CRCFLG	; ...crc mode.
	MVI	A,NAK	; send nak to tell sender checksum
	CALL	SEND	; ...is in effect & to start sending.
	JMP	RCVSECT	; go start receiving sector

RCVSQ2	MVI	B,7	;  7-sec time-out
	CALL	RECV
	JC	RCVSTOT
RCVSQ3	CALL	RCVERR	; check for errors
	JC	RCVDERR	; jump if there was an error
	CPI	SOH
	JZ	RCVSOH
	ORA	A
	JZ	RCVSQ
	CPI	EOT
	STC
	RZ
	MOV	B,A
	LDA	VSEEFLG
	ORA	A
	JZ	RCVSEH
	LDA	QFLG
	ORA	A
	JZ	RCVSERR
RCVSEH	MOV	A,B
	CALL	CRLF
	CALL	HEXO
	CALL	ILPRT
	DB	'H received, not SOH',CR,LF,0
RCVSERR MVI	B,1	;  1-sec time-out
	CALL	RECV
	JNC	RCVSERR
	MVI	A,NAK
	CALL	SEND
	LDA	ERRCT
	INR	A
	STA	ERRCT
	DCR	A
	CPI	ERRLIM
	JC	RCVRPT
	LDA	VSEEFLG
	ORA	A
	JZ	RCVCKQ
	LDA	QFLG
	ORA	A
	JZ	RCVSABT
RCVCKQ	CALL	CKQUIT
	JZ	RCVSECT
RCVSABT	CALL	CLOSFIL
	CALL	ERXIT
	DB	'++ UNABLE TO RECEIVE SECTOR -- ABORTING ++',CR,LF,BELL,'$'
RCVSTOT	LDA	VSEEFLG
	ORA	A
	JZ	RCVSPT
	LDA	QFLG
	ORA	A
	JZ	RCVSERR
RCVSPT	CALL	ILPRT
	DB	CR,LF,'++ TIME-OUT ++ ',BELL,0
RCVPRN	LDA	ERRCT
	CALL	HEXO
	CALL	CRLF
	JMP	RCVSERR

; checks for framing, overrun, and parity errors. parity
; errors cannot be detected unless the parity option has
;been selected.
;
; 1. error code (errcde) was set in recv routine.
; 2. errcde = 0 for no errors, errcde <> 0 for errors.
; 3. on an error, routine returns with carry flag set.

RCVERR	PUSH	PSW	; save char transmitted
	LDA	ERRCDE	; get receive error code
	ANA	A	; is it zero?
	JZ	RCVERR2	; yes, no receive error
	POP	PSW	; restore char transmitted
	STC		; set carry on to indicate an error
	RET

RCVERR2	POP	PSW	; restore char transmitted
	RET

; checks for a receive error and displays
; appropriate error message. then goes to rcvserr to
; purge the line and send a nak.

RCVDERR	LDA	VSEEFLG	; viewing
	ORA	A	; ...mode?
	JZ	RCVDERRP	; yes,..prt msg
	LDA	QFLG	; quiet...
	ORA	A	; ...mode?
	JZ	RCVSERR	; yes, no msg
RCVDERRP
	CALL	ILPRT
	DB	CR,LF,0
	LDA	ERRCDE	; get receive err code
	ANI	FRMER	; was there a framing error?
	JZ	RCVDERR2	; no, go check for overrun
	CALL	ILPRT
	DB	'++ FRAMING error ++ ',BELL,0
	CALL	RCVDERR5	; print # of error
RCVDERR2
	LDA	ERRCDE	; get receive err code
	ANI	ORUNER	; was there an overrun
	JZ	RCVDERR3	; no, go check for parity error
	CALL	ILPRT
	DB	'++ OVERRUN error ++ ',BELL,0
	CALL	RCVDERR5
RCVDERR3
	LDA	ERRCDE	; get receive err code
	ANI	PARER	; was there a parity error?
	JZ	RCVDERR4	; no, go purge line
	CALL	ILPRT
	DB	'++ PARITY error ++ ',BELL,0
	CALL	RCVDERR5
RCVDERR4
	JMP	RCVSERR	; go purge line, send nak

; display the number of the error, do a crlf.

RCVDERR5
	LDA	ERRCT	; get error number
	CALL	HEXO	; display it in hex
	CALL	CRLF	; do cr, lf
	RET

RCVSOH	MVI	B,1	;  1-sec time-out
	CALL	RECV
	JC	RCVSTOT
	CALL	RCVERR	; check for receive error
	JC	RCVDERR
	MOV	D,A
	MVI	B,1
	CALL	RECV
	JC	RCVSTOT
	CALL	RCVERR	; check for receive error
	JC	RCVDERR
	CMA
	CMP	D
	JZ	RCVDATA
	LDA	VSEEFLG
	ORA	A
	JZ	RCVBSE
	LDA	QFLG
	ORA	A
	JZ	RCVSERR
RCVBSE	CALL	ILPRT
	DB	CR,LF,'++ Bad Header Identifier ++',CR,LF,BELL,0
	JMP	RCVSERR

RCVDATA	MOV	A,D
	STA	RCVSNO
	MVI	A,1
	STA	DATAFLG
	MVI	C,0
	CALL	CLRCRC	; clear crc counter
	LXI	H,80H
RCVCHR	MVI	B,1
	CALL	RECV
	JC	RCVSTOT
	CALL	RCVERR	; check for receive error
	JC	RCVDERR
	MOV	M,A
	INR	L
	JNZ	RCVCHR
	LDA	CRCFLG
	ORA	A
	JZ	RCVCRC
	MOV	D,C
	XRA	A
	STA	DATAFLG
	MVI	B,1
	CALL	RECV
	JC	RCVSTOT
	CALL	RCVERR	; check for receive error
	JC	RCVDERR
	CMP	D
	JNZ	RCVCERR
CHKSNUM	LDA	RCVSNO
	MOV	B,A
	LDA	SECTNO
	CMP	B
	JZ	RECVACK
	INR	A
	CMP	B
	JNZ	ABORT
	RET

RCVCRC	MVI	E,2	; nr of crc bytes
RCVCRC2	MVI	B,1
	CALL	RECV
	JC	RCVSTOT
	CALL	RCVERR
	JC	RCVDERR
	DCR	E
	JNZ	RCVCRC2
	CALL	CHKCRC
	ORA	A
	JZ	CHKSNUM
	LDA	VSEEFLG
	ORA	A
	JZ	RCVCRER
	LDA	QFLG
	ORA	A
	JZ	RCVSERR
RCVCRER	CALL	ILPRT
	DB	CR,LF,'++ CRC error ++ ',BELL,0
	JMP	RCVPRN

RCVCERR	LDA	VSEEFLG
	ORA	A
	JZ	RCVCPR
	LDA	QFLG
	ORA	A
	JZ	RCVSERR
RCVCPR	CALL	ILPRT
	DB	CR,LF,'++ CHECKSUM error ++ ',BELL,0
	JMP	RCVPRN

RECVACK	CALL	SENDACK
	JMP	RCVSECT

SENDACK	MVI	A,ACK
	CALL	SEND
	RET

SENDHDR	LDA	QFLG
	ORA	A
	JZ	SENDHNM
	CALL	ILPRT
	DB	CR,'Sending Data Block # ',0
	PUSH	H
	LHLD	SECTNO	; get sector number
	CALL	DECOUT	; print it in decimal
	CALL	ILPRT
	DB	' (',0
	CALL	DHXOUT	;  16-bit hex conversion & output
	CALL	ILPRT
	DB	'H)',0
	POP	H
SENDHNM	MVI	A,SOH
	CALL	SEND
	LDA	SECTNO
	CALL	SEND
	LDA	SECTNO
	CMA
	CALL	SEND
	RET

SENDSEC	MVI	A,1
	STA	DATAFLG
	MVI	C,0
	CALL	CLRCRC
	LXI	H,80H
SENDC	MOV	A,M
	CALL	SEND
	INR	L
	JNZ	SENDC
	XRA	A
	STA	DATAFLG
	RET

SENDCKS	MOV	A,C
	CALL	SEND
	RET

SENDCRC	CALL	FINCRC
	MOV	A,D
	CALL	SEND
	MOV	A,E
	CALL	SEND
	XRA	A
	RET

GETACK	MVI	B,7	;  7-sec time-out
	CALL	RECVDG
	JC	GETATOT
	CPI	ACK
	RZ
	MOV	B,A
	LDA	QFLG
	ORA	A
	JZ	ACKERR
	MOV	A,B
	CALL	CRLF
	CALL	HEXO
	CALL	ILPRT
	DB	'H received, not ACK',CR,LF,0
ACKERR	LDA	ERRCT
	INR	A
	STA	ERRCT
	DCR	A
	CPI	ERRLIM
	RC
	LDA	VSEEFLG
	ORA	A
	JZ	GACKV
	LDA	QFLG
	ORA	A
	JZ	CSABORT
GACKV	CALL	CKQUIT
	STC
	RZ
CSABORT	CALL	ERXIT
	DB	CR,LF,'++ UNABLE TO SEND SECTOR -- ABORTING ++',CR,LF,BELL,'$'
GETATOT	LDA	QFLG
	ORA	A
	JZ	ACKERR
	CALL	ILPRT
	DB	CR,LF,'++ TIME-OUT on ACK ++',CR,LF,BELL,0
	JMP	ACKERR

CKABORT	LDA	VSEEFLG
	ORA	A
	JZ	CKABGO
	LDA	QFLG
	ORA	A
	RZ	
CKABGO	CALL	STAT
	RZ
	CALL	KEYIN
	CPI	CAN
	RNZ
ABORT	LXI	SP,STACK
ABORTL	MVI	B,1
	CALL	RECV
	JNC	ABORTL
	MVI	A,CAN
	CALL	SEND
ABORTW	MVI	B,1
	CALL	RECV
	JNC	ABORTW
	MVI	A,' '
	CALL	SEND
	CALL	ILPRT
	DB	CR,LF,'++ ROUTINE CANCELLED ++',CR,LF,LF,BELL,0
	MVI	A,'B'	; turn multi-file mode..
	STA	BATCHFLG	; ..off so routine ends.
	JMP	DONETCE

INCRSNO	PUSH	H
	LHLD	SECTNO	; get sector number
	INX	H	; bump it
	SHLD	SECTNO	; store it
	MOV	A,L
	POP	H
	RET

ERASFIL	LDA	BATCHFLG	; don't ask for erase..
	ORA	A	; ..in multi-file mode,..
	JZ	NOASK	; ..just do it.
	LXI	D,FCB
	MVI	C,SRCHF
	CALL	BDOS
	INR	A
	RZ
	CALL	ILPRT
	DB	CR,LF,'File exists -- erase (Y>es/N>o): ',BELL,0
	CALL	KEYIN
	CALL	UCASE
	CALL	TYPE
	CPI	'Y'
	CALL	CRLF
	JNZ	MENU
NOASK	LXI	D,FCB
	MVI	C,ERASE
	CALL	BDOS
	RET

BLKFILE	CALL	ILPRT	; if no file is named with "s" or "r"
	DB	'++ NO FILE SPECIFIED ++',CR,LF,BELL,0
	JMP	MENU

MAKEFIL	LXI	D,FCB
	MVI	C,MAKE
	CALL	BDOS
	INR	A
	RNZ
	CALL	ERXIT
	DB	'++ ERROR - Directory may be full ++',CR,LF,BELL,'$'

; determine file record count

CNREC	MVI	C,COMPSZ	; compute file size function
	LXI	D,FCB	; point to file control block
	CALL	BDOS
	LHLD	FCB+33	; get record count
	SHLD	RCNT	; store it
	LXI	H,0	; zero hl
	SHLD	FCB+33	; reset random record in fcb
	RET

OPENFIL	LXI	D,FCB
	MVI	C,OPEN
	CALL	BDOS
	INR	A
	JNZ	OPENOK
	CALL	ERXIT
	DB	CR,LF,'++ UNABLE TO OPEN FILE ++',CR,LF,BELL,'$'
OPENOK	LDA	BATCHFLG
	ORA	A
	JNZ	OPENOK1
	LDA	QFLG
	ORA	A
	RZ
OPENOK1	CALL	ILPRT
	DB	CR,LF,'Ready to Send -- file contains ',0
	LHLD	RCNT	; get record count
	CALL	DECOUT	; print number of sectors in decimal
	CALL	ILPRT	; print
	DB	' (',0
	CALL	DHXOUT
	CALL	ILPRT
	DB	'H) sectors',CR,LF
	DB	'File send-time is ',0
	MVI	A,14	; factor for 300 baud
	LHLD	RCNT	; get # of sectors
S300	CALL	DIVHLA	; divide hl by value in a (sectors/min)
	PUSH	H
	MVI	H,0
	CALL	DECOUT	; print decimal # of minutes
	CALL	ILPRT
	DB	' mins, ',0
	POP	H
	MOV	A,H	; remainder x 4 = seconds
	RLC
	RLC
	MOV	L,A
	MVI	H,0
	CALL	DECOUT
	CALL	ILPRT
	DB	' seconds at 300 baud.',CR,LF,0
XMSG	CALL	ILPRT
	DB	'Enter <CTRL-X> to Cancel File Transfer',CR,LF,0
	RET

; divlha: divides hl by value in a,
; upon exit: l=quotient, h=remainder

DIVHLA	PUSH	B
	MVI	B,8	; shift factor to b
	MOV	C,A	; divisor to c
DIV2	XRA	A	; clear carry flag and accumulator
	DAD	H
	MOV	A,H
	SUB	C
	JM	DIV3	; don't borrow on neg results
	MOV	H,A
	MOV	A,L
	ORI	1	; borrow 1
	MOV	L,A
DIV3	DCR	B
	JNZ	DIV2
	POP	B
	RET

; mulha: multiply the value in the h by the value in the a
; return with the answer in the hl.

MULHA	MOV	B,A	; put loop count in b
	MVI	D,0
	MOV	E,H
	MOV	L,H
	MVI	H,0
MULLP	DCR	B
	RZ
	DAD	D
	JMP	MULLP
	RET

; close file

CLOSFIL	LXI	D,FCB	; point to file name
	MVI	C,CLOSE
	CALL	BDOS
	INR	A	;  ffh --> 00 if close ok
	RNZ	; yes, return, else..
	CALL	ERXIT	; ..abort.
	DB	CR,LF,'++ UNABLE TO CLOSE FILE ++',CR,LF,BELL,'$'

; read a sector

RDSECT	LDA	SECINBF
	DCR	A
	STA	SECINBF
	JM	RDBLOCK
	LHLD	SECPTR
	LXI	D,80H
	CALL	MOVE128
	SHLD	SECPTR
	RET

; buffer empty -- read in another block (128 sectors)

RDBLOCK	LDA	EOFLG
	CPI	1
	STC
	RZ
	MVI	C,0
	LXI	D,DBUF
RDSECLP	PUSH	B
	PUSH	D
	MVI	C,SETDMA
	CALL	BDOS
	LXI	D,FCB
	MVI	C,READ
	CALL	BDOS
	POP	D
	POP	B
	ORA	A
	JZ	RDSECOK
	DCR	A
	JZ	REOF
	CALL	ERXIT
	DB	CR,LF,'++ FILE READ ERROR ++',CR,LF,BELL,'$'
RDSECOK	LXI	H,80H
	DAD	D
	XCHG
	INR	C
	MOV	A,C
	CPI	DBUFSIZ*8	; buffer size (128-128 byte sectors)
	JZ	RDBFULL	 	; read-buffer full?
	JMP	RDSECLP	 	; no, loop for another sector.

REOF	MVI	A,1
	STA	EOFLG
	MOV	A,C

; buffer full or received eof

RDBFULL	STA	SECINBF
	LXI	H,DBUF
	SHLD	SECPTR
	LXI	D,80H
	MVI	C,SETDMA
	CALL	BDOS
	JMP	RDSECT

; write a sector

WRSECT	LHLD	SECPTR
	XCHG
	LXI	H,80H
	CALL	MOVE128
	XCHG
	SHLD	SECPTR
	LDA	SECINBF
	INR	A
	STA	SECINBF
	CPI	DBUFSIZ*8	; buffer size
	RNZ

; write block to disk (128 sectors)

WRBLOCK	LDA	SECINBF
	ORA	A
	RZ
	MOV	C,A
	LXI	D,DBUF
DKWRLP	PUSH	H
	PUSH	D
	PUSH	B
	MVI	C,SETDMA
	CALL	BDOS
	LXI	D,FCB
	MVI	C,WRITE
	CALL	BDOS
	POP	B
	POP	D
	POP	H
	ORA	A
	JNZ	WRERR
	LXI	H,80H
	DAD	D
	XCHG
	DCR	C
	JNZ	DKWRLP
	XRA	A
	STA	SECINBF
	LXI	H,DBUF
	SHLD	SECPTR
	RET

WRERR	MVI	C,CAN
	CALL	SEND
	CALL	ERXIT
	DB	'++ ERROR WRITING FILE ++',CR,LF,BELL,'$'

; receive a character.  time-out time is in b, in seconds.
; entry via 'recvdg' deletes garbage characters on the line.  for
; example, having just sent a sector, calling recvdg will delete
; any line noise induced characters long before the ack/nak would
; be received.

RECVDG	CALL	INDATA
	CALL	INDATA
RECV	PUSH	D
MSEC	LXI	D,7500*MHZ	; cycles to make b-reg seconds
	CALL	CKABORT
MWTI	CALL	INCTL
	ANI	MODRCVB
	CPI	MODRCVR
	JZ	MCHAR
	DCR	E
	JNZ	MWTI
	DCR	D
	JNZ	MWTI
	DCR	B
	JNZ	MSEC
	POP	D
	STC		; carry shows time-out
	RET

MCHAR	CALL	INCTL	; get error-status byte
	ANI	ERRCDMSK	; mask out all except error bits (3-5)
	STA	ERRCDE	; save the error code
MCHAR1	CALL	INDATA
	POP	D
	PUSH	PSW
	CALL	UPDCRC	; calc crc
	ADD	C	
	MOV	C,A
	LDA	RSEEFLG
	ORA	A
	JZ	MONIN
	LDA	VSEEFLG
	ORA	A
	JNZ	NOMONIN
	LDA	DATAFLG
	ORA	A
	JZ	NOMONIN
MONIN	POP	PSW
	PUSH	PSW
	CALL	SHOW
NOMONIN	POP	PSW
	ORA	A
	RET

SEND	PUSH	PSW
	LDA	SSEEFLG
	ORA	A
	JZ	MONOUT
	LDA	VSEEFLG
	ORA	A
	JNZ	NOMONOT
	LDA	DATAFLG
	ORA	A
	JZ	NOMONOT
MONOUT	POP	PSW
	PUSH	PSW
	CALL	SHOW
NOMONOT	POP	PSW
	PUSH	PSW
	CALL	UPDCRC		; calc crc
	ADD	C
	MOV	C,A
SENDW	CALL	INCTL
	ANI	MODSNDB
	CPI	MODSNDR
	JNZ	SENDW
	POP	PSW
	CALL	OUTDATA
	RET

; waits for 1st received char.  time-out in e-reg.

WAITNAK	LDA	VSEEFLG
	ORA	A
	JZ	WAITNPR
	LDA	QFLG
	ORA	A
	JZ	WAITNLP
WAITNPR	CALL	ILPRT
	DB	'Awaiting initial "C" (CRC mode) or NAK (CHECKSUM mode)'
	DB	CR,LF,0
WAITNLP	CALL	CKABORT
	MVI	B,1
	CALL	RECV
	CPI	NAK
	RZ
	CPI	CRC		; crc request?
	JZ	WAITCRC		; yes, go set crc flag
	DCR	E	; time-out in seconds
	JZ	ABORT
	JMP	WAITNLP

WAITCRC	CALL	ILPRT
	DB	'CRC request received',CR,LF,0
	XRA	A
	STA	CRCFLG
	RET

; initialize the console i/o addresses

INITADR	LHLD	1	; entry to bios jmp tables
	LXI	D,3
	DAD	D
	SHLD	VSTAT+1
	DAD	D
	SHLD	VKEYIN+1
	DAD	D
	SHLD	VTYPE+1
	RET

; validate secondary command-mode options

PROCOPT	LXI	D,FCB+1
	LDAX	D
	STA	OPTION
OPTLP	INX	D
	LDAX	D
	CPI	' '	; delimiter for filename beginning/end.
	JZ	ENDOPT
	LXI	H,OPTBL
	MVI	B,OPTBE-OPTBL
OPTCK	CMP	M
	JNZ	OPTNO
	MVI	M,0
	JMP	OPTLP

OPTNO	INX	H
	DCR	B
	JNZ	OPTCK
	JMP	BADOPT	; option not valid, show message

ENDOPT	LDA	CRCFLG
	ORA	A
	JNZ	ENDOPT2
	LDA	OPTION
	CPI	'R'
	JNZ	BADOPT	; crc allowed for receive, but not send.
ENDOPT2	LDA	VSEEFLG
	ORA	A
	RNZ
	STA	QFLG
	RET

; file transfer completed

DONE	LDA	BATCHFLG
	ORA	A
	JNZ	DONETCC
	LDA	QFLG
	ORA	A
	JZ	NMSTRNS
	LXI	H,FCB+1	; put file name in..
	LXI	D,FTRNMSG	; ..spaces in message..
	MVI	B,8	; ..below.
	CALL	MOVE
	INX	D	; put file type after..
	MVI	B,3	; ..skipping one space..
	CALL	MOVE	; ..below.	
	CALL	ILPRT
FTRNMSG	DB	'              transferred',CR,LF,LF,0	; 13 spaces
NMSTRNS	LDA	FCB	; save drive #
	STA	DISKNO
	LXI	H,FCB	; blank out file control blocks
	CALL	INITFCBS
	LDA	DISKNO	; put drive number back
	STA	FCB
	LXI	H,RESTSN; restore sector numbers..
	LXI	D,SECTNOB	; ..for new file transfer.
	MVI	B,SECTNOE-SECTNOB	; routine also done in menu.
	CALL	MOVE
	LDA	SENDFLG	; goes to either send or..
	ORA	A	; ..receive file, depending..
	JNZ	SENDFIL	; ..upon which routine set..
	JMP	RCVFIL1	; ..the flag in multi-file mode.

DONETCC	MVI	A,TRUE	; indicate no files being..
	STA	FSTFLG	; ..reset. multifile transfer..
	STA	NFILFLG	; ..used in terminal routine.
	CMA
	STA	ALERTFG
	STA	SAVEFLG	; stop memory save in term routine.
	LDA	VSEEFLG
	ORA	A
	JZ	DONETC
	LDA	QFLG
	ORA	A
	JZ	DONETCA
DONETC	CALL	ILPRT
	DB	CR,LF,'++ ALL TRANSFERS COMPLETED ++',CR,LF,BELL,0
DONETCA	LDA	DISCFLG	; see if disconnect when thru..
	ORA	A
	JNZ	DONETCE	; ..no, don't disconnect.
DONETCB	CALL	ILPRT
	DB	CR,LF,'Press <RETURN> to disconnect ',BELL,CR,LF,0
	MVI	C,RDCON
	CALL	BDOS	; wait for response
	CPI	CR	; carriage return yet?
	JNZ	DONETCB	; nope!
	CALL	ILPRT
	DB	CR,LF,'++ DISCONNECTED ++',CR,LF,0
	CALL	DISCONN	; hang-up the Mark VII
	JMP	EXIT	; go to cp/m

DONETCE	MVI	A,CRC
	STA	CRCFLG	; turn off crc option
	MVI	A,TRUE
	STA	FIRSTME	; set first-time flag
	LDA	TERMFLG	; see if return to..
	ORA	A	; ..terminal mode..
	JNZ	MENU	; ..after x'fer.
	JMP	TERM

; fcb2 moved to fcb location, record and extent #'s zero'd.

MOVEFCB	LXI	H,FCB+16
	LXI	D,FCB
	MVI	B,16
	CALL	MOVE
	XRA	A
	STA	FCBRNO
	STA	FCBEXT
	RET

; display send/receive characters plus cr, lf, and tab.  other
; non-printing characters are shown in hex as (xx).

SHOW	CPI	LF
	JZ	CTYPE
	CPI	CR
	JZ	CTYPE
	CPI	9
	JZ	CTYPE
	CPI	' '
	JC	SHOWHEX
	CPI	7FH
	JC	CTYPE
SHOWHEX	PUSH	PSW
	MVI	A,'('
	CALL	CTYPE
	POP	PSW
	CALL	HEXO
	MVI	A,')'
	JMP	CTYPE

; workhorse routines

ILPRT	XTHL	; exchange top of stack and hl-reg and..
ILPLP	MOV	A,M	; ..get msg.
	CALL	CTYPE
	INX	H	; get next char and test..
	ORA	A	; ..for end of msg.
	JNZ	ILPLP
	XTHL
	RET

PRTMSG	MVI	C,PRINT	; string out to console, unto "$".
	JMP	BDOS

CTYPE	PUSH	PSW
	PUSH	B
	PUSH	D
	PUSH	H
	MOV	E,A
	MVI	C,WRCON
	CALL	BDOS
	POP	H
	POP	D
	POP	B
	POP	PSW
	RET

CRLF	PUSH	PSW	; a cr and a lf
	MVI	A,CR
	CALL	TYPE
	MVI	A,LF
	CALL	TYPE
	POP	PSW
	RET

CRONLY	PUSH	PSW	; a simple cr without a lf
	MVI	A,CR
	CALL	TYPE
	POP	PSW
	RET

TYPE	PUSH	PSW
	PUSH	B
	PUSH	D
	PUSH	H
	MOV	C,A
VTYPE	CALL	$-$	; address set at initadr
	POP	H
	POP	D
	POP	B
	POP	PSW
	RET

STAT	PUSH	B
	PUSH	D
	PUSH	H
VSTAT	CALL	$-$
	POP	H
	POP	D
	POP	B
	ORA	A	;  0 => not ready
	RET

KEYIN	PUSH	B
	PUSH	D
	PUSH	H
VKEYIN	CALL	$-$
	POP	H
	POP	D
	POP	B
	RET

UCASE	CPI	61H	; changes lower case character..
	RC		; ..in a-reg to upper case.
	CPI	7BH
	RNC
	ANI	5FH
	RET

; decimal pretty print

DECOUT	PUSH	PSW
	PUSH	B
	PUSH	D
	PUSH	H
	LXI	B,-10
	LXI	D,-1
DECOU2	DAD	B
	INX	D
	JC	DECOU2
	LXI	B,10
	DAD	B
	XCHG
	MOV	A,H
	ORA	L
	CNZ	DECOUT
	MOV	A,E
	ADI	'0'
	CALL	CTYPE
	POP	H
	POP	D
	POP	B
	POP	PSW
	RET

; 16-bit hex output routine

DHXOUT	PUSH	H
	PUSH	PSW
	MOV	A,H	; get ms byte
	CALL	HEXO	; output high order byte
	MOV	A,L	; get ls byte
	CALL	HEXO	; output low order byte
	POP	PSW
	POP	H
	RET

HEXO	PUSH	PSW
	RAR
	RAR
	RAR
	RAR
	CALL	NIBBL
	POP	PSW
NIBBL	ANI	0FH
	CPI	10
	JC	ISNUM
	ADI	7
ISNUM	ADI	'0'
	JMP	TYPE

; returns with zero set if retry asked.  if multi-file mode, then
; no questions asked, just quit.

CKQUIT	LDA	BATCHFLG
	ORA	A
	JNZ	CKQTASK	; ask for retry
	INR	A	; reset zero flg
	RET

CKQTASK	MVI	A,1
	STA	ERRCT
	CALL	ILPRT
	DB	'Multiple errors encountered -- Q>uit/R>etry: '
	DB	BELL,0
	CALL	KEYIN
	CALL	UCASE
	CALL	CRLF
	CPI	'R'
	RZ
	CPI	'Q'
	JNZ	CKQUIT
	ORA	A
	RET

ERXIT	POP	D
	CALL	PRTMSG
	LDA	BATCHFLG
	ORA	A
	JNZ	DONETCE
	MVI	A,'Q'	; reset qflg
	STA	QFLG
	JMP	ABORT	; abort other computer

; leave the modem program

PREEXIT	LDA	LINEFLG	; skip msg if telephone not connected
	ORA	A
	JZ	EXIT
	CALL	ILPRT
	DB	CR,LF,LF,'Exit to CP/M with telephone line '
	DB	'connected? (Y>es/N>o): ',0
	CALL	KEYIN
	CALL	UCASE
	CALL	TYPE
	CPI	'Y'
	JZ	EXIT	; yes, with line connected.  any other..
	CALL	DISCONN	; ..char disconnects/exits to cp/m.
EXIT	LXI	D,80H	; tidy up before leaving modem
	MVI	C,SETDMA
	CALL	BDOS
	CALL	CRLF	; exit to cp/m with a fresh line
	LHLD	STACK	; load hl from memory at location stack
	SPHL	; copy address from hl to sp
	LDA	SAVCCP	; see if ccp saved..
	ORA	A
	JZ	0	; ..yes, noisily warm boot.  else..
	RET		; ..restore cp/m stack pointer.

; move contents pointed to by hl to de, count in b.

MOVE128	MVI	B,128
MOVE	MOV	A,M
	STAX	D	; store a-reg in memory, address in de.
	INX	H
	INX	D
	DCR	B
	JNZ	MOVE
	RET

DIALPL	XRA	A
	STA	CRFLAG	; continuous redial flag
	CALL	DIALPL0	; disconnect, reconnect, wait dial tone
	LXI	H,CMDBUF+1	; point # of chars in buff
	MOV	A,M	; get # of chars
	CPI	4	;  4 or more chars typed before <return>?
	JC	ENTNUM	; no, ask for number
	LXI	H,CMDBUF+6	; point to number to dial
	JMP	DIAL10	; check if library # then dial

DIALPL0	CALL	DISCONN
	CALL	ILPRT
	DB	ESC,ETEOL
	DB	'           WAITING FOR DIAL TONE',CR,0
	LDA	MODE	; make make (off-hook)
	ANI	9FH
	CALL	OUTCTL
	MVI	D,DTMSK	; dial tone mask
	MVI	C,100	; 10 second wait
	CALL	WAIT	; wait for dial tone delay
	RET

; set-up for the print at entnum2

ENTNUM	CALL	ILPRT
	DB	CR,LF,LF
	DB	HT,'        M o d e m',CR,LF
	DB	HT,'    T e l e p h o n e',CR,LF
	DB	HT,'      L i b r a r y',CR,LF,LF,0
	MVI	C,13	; number of lines to move
	LXI	H,NUMBLIB 	; address of source memory..
	LXI	D,DBUF	; ..and target memory.
ENTNUM1	MVI	B,34	; number of bytes..
	CALL	MOVE	; ..to move to buffer.
	MVI	A,' '	; 	   space (4+(2*34)=72)
	STAX	D
	INX	D
	STAX	D
	INX	D	;  2
	STAX	D
	INX	D
	STAX	D
	INX	D	;  4
	MVI	B,34
	CALL	MOVE
	MVI	A,CR	; cr (newline)
	STAX	D	; store it
	MVI	A,LF	; lf
	INX	D	; bump pointer
	STAX	D	; store lf
	INX	D	; bump pointer
	DCR	C	; number of lines to print
	JNZ	ENTNUM1
ENTNUM2	MVI	A,'$'
	STAX	D
	MVI	C,PRINT
	LXI	D,DBUF	; point to table of numbers to print
	CALL	BDOS
	CALL	ILPRT
	DB	CR,LF,'Enter library letter or phone number -- '
	DB	'press <RETURN> to start dialing.',CR,LF
	DB	'<CTRL-X> aborts dialing routine: ',0
	LXI	D,CMDBUF
	CALL	INBUFF	; a macro from ml.lib
	CALL	CRLF
	CALL	CRLF
DIALLP1	LDA	CMDBUF+1  	; dial #
	ORA	A	  	; null means <return> pressed hence..
	JZ	BORTIT	  	; ..abort dialing, return to menu.
	LXI	H,CMDBUF+2	; first typed char of number to dial

; enter this routine with hl pointing to number to dial

DIAL10	MVI	B,'A'	; first letter of alphabet
	MVI	E,0	; counts number of letters to match
	MVI	C,26	; number of letters in alphabet
	MOV	A,M	; get char buffer
DIAL11	CMP	B	; number from table?
	JZ	LIBSET
	INR	B	; make next letter (a-z)
	INR	E	; count up
	DCR	C	; count down
	JZ	DIALLPX	; not a letter
	JMP	DIAL11	; loop

LIBSET	LXI	H,NUMBLIB	; phone number library
	LXI	B,34	; length of library entry
	MOV	A,E	; number of times to add 34 to hl
	ORA	A	; set flags
	JZ	DIAL13
DIAL12	MOV	A,M	; get first char of selected lib entry
	ORA	A	; set flags
	JZ	DIALLP2	; send badlib msg
	DAD	B	; increment hl by 34
	DCR	E	; countdown
	JNZ	DIAL12	; not there yet, loop
DIAL13	MVI	B,34	; number of characters to get from table
	LXI	D,CMDBUF+1	; point to buffer
	XCHG		; hl points to cmdbuf+1 (exchange de/hl)
	MOV	M,B	; store # of bytes in a table entry
	XCHG		; restore regs
	INX	D	; point to first char position in buffer
	CALL	MOVE	; move table entry to buffer
DIALLPX	LDA	CMDBUF+1
	MOV	E,A	; number of chars in buff
	LXI	H,CMDBUF+2	; point first char
DIALLP2	MOV	A,M	; get first # from buffer

; routine to print 'badlib' message, abort if null encountered

	ORA	A	; set flags
	PUSH	D	; save de registers
	LXI	D,BADLIB	; bad library number if null
	MVI	C,PRINT
	PUSH	PSW	; save a and flags
	CZ	BDOS
	POP	PSW	; restore a and flags
	POP	D	; restore de registers
	JZ	BORTIT0	; abort

; dial a digit, check kbd for abort

	CALL	DIAL	; dial it
	CALL	STAT	; keypress?
	ORA	A	; set flags
	CNZ	KEYIN	; yes, go get it
	CPI	CAN	;  ^x?
	JZ	BORTIT	; yes, abort
	INX	H	; bump pointer
	PUSH	D	; save de
	PUSH	H	; save hl
	MVI	B,1	; wait 1 time interval (.1 sec)
	CALL	TIMER
	POP	H	; restore hl
	POP	D	; restore de
	DCR	E	; count down chars in buff
	JNZ	DIALLP2	; not done, loop
	JMP	DIALDN	; dialing done

BADLIB	DB	CR,LF,'++ BAD LIBRARY NUMBER CALLED ++',CR,LF,BELL,'$'

DISCONN XRA	A	; store a disconnected condition
	STA	LINEFLG
	LDA	MODE
	ANI	9FH
	ORI	40H	
	CALL	OUTCTL	; hang-up
	PUSH	B
	MVI	B,8	; wait for Mark VII to disconnect
	CALL	TIMER
	POP	B
	RET

TIMER	MVI	A,TRATE	; trate = 250 for .1 sec interval.
TIMES	DCR	A
	JNZ	TIMES
	DCR	B	; b-reg has # of .1 sec intervals.
	JNZ	TIMER
	RET

BORTIT0 CALL	CRLF
BORTIT	CALL	DISCONN	; disconnect
	JMP	MENU	; restores option table and shows prompt

; auto dialer

DIAL	CALL	TYPE	; print whatever character, dashes, etc.
	CPI	30H
	RC		; digit must be at least 0..
	CPI	'R'	; could it be a ringback character
	JNZ	DIAL1	; no? - jump
	PUSH	PSW	; save accumulator & flags
	MOV	A,E	; get # of char left into acc.
	CPI	01H	; is this the last character?
	JZ	RINGBK	; yes, it must be ringback char, ringback.
	POP	PSW	; everything back as it was
DIAL1	CPI	3AH
	RNC		; ..and not more than 9 (numeral parser).
	ANI	0FH	; strip ascii
	JNZ	DIALS
	MVI	A,10	; convert zero to 10 pulses
DIALS	MOV	C,A
	LDA	PULSERATE	; contains value for dial speed
	CALL	OUT$BAUDRP
DIALC	CALL	IN$BAUDRP
	ANI	TMPUL
	JNZ	DIALC
DIALB	CALL	IN$BAUDRP
	ANI	TMPUL
	JZ	DIALB
MAKEP	MVI	A,MAKEM
	CALL	OUTCTL
TIMEM	CALL	IN$BAUDRP
	ANI	TMPUL
	JNZ	TIMEM
	MVI	A,BRKM
	CALL	OUTCTL
TIMEB	CALL	IN$BAUDRP
	ANI	TMPUL
	JZ	TIMEB
	DCR	C
	JNZ	MAKEP
	MVI	A,MAKEM
	CALL	OUTCTL
	MVI	B,2
	CALL	TIMER
	RET

RINGBK	POP	PSW	; to get it off the stack
	LDA	CMDBUF+1	; get # of char in buffer
	SUI	01 	; subtract 1 to avoid the ringback char
	STA	CMDBUF+1	; store the new value
	MVI	D,DTMSK	; load tone detect mask
	MVI	C,RBLMT	; set timer for rblmt number of seconds
	CALL	WAIT
	JC	RBTIME	; jump if no ring detected
	MVI	B,25	; wait 2.5 sec
	CALL	TIMER
	CALL	IN$BAUDRP	; is tone still present?
	ANA	D
	JNZ	RNGBK1
	JMP	DILAGN	; yes, must be busy

RNGBK1	CALL	HANGP	; hang up the phone
	MVI	B,RBWAIT; wait x sec
	CALL	TIMER
	CALL	DIALPL0	; go off hook & listen for dial tone
	JNC	DIALLPX	; dial number
	JMP	MENU1

RBTIME	CALL	CRONLY	; just a carriage return
	JMP	RNGBK1	; hangup, redial, & listen for carrier

; # of seconds * 10 in c-reg.  check kbd for abort.

WAIT	MVI	B,1	
	CALL	TIMER	; wait for timer to go high then low
	PUSH	B
	PUSH	D	; save active reg's then..
	CALL	STAT	; keypress?
	ORA	A	; set flags
	CNZ	KEYIN	; yes, get char
	CPI	CAN	;  ^x?
	JZ	WAIT1	; yes, disconnect, jmp to menu
	POP	D
	POP	B	; ..restore.
	DCR	C	; count-down
	JNZ	WAIT
	STC	; set carry to indicate mask not set
	RET

WAIT1	POP	D	; reset..
	POP	B	; ..stack then..
	JMP	BORTIT0	; ..disconnect, show command prompt.

HANGP	CALL	DISCONN
	RET

DIALDN	CALL	CRONLY	; just a carriage return
	MVI	A,07FH	; turn on dtr
	CALL	OUTCTL
	MVI	B,1
	CALL	TIMER	; wait for modem to turn on dtr
	MVI	A,5DH	; 2 stop bits, no parity, 8 data bits
			;  + no disconnect after 17 secs
	CALL	OUTCTL
	MVI	D,4	 	; clear to send (cts) mask
	MVI	C,WAITCTS	; wait time for cts
	CALL	WAIT
	MVI	C,WAITCTS	; repeat to get up to 51 seconds max
	CALL	WAIT
	JNC	CONMADE	; connection made
	CALL	DISCONN
DILAGN	LDA	CRFLAG	; continuous redial flag
	ORA	A
	JNZ	DILAGN0
	CALL	ILPRT
	DB	'No answer after normal time-out.  Re-dial?  '
	DB	'Y>es, N>o, or C>ontinuous: ',BELL,0
	CALL	KEYIN	; get response
	CALL	UCASE
	CALL	TYPE	; echo it
	CALL	CRONLY	; overwrite with new line to be dialed
	CPI	'N'	; redial?
	JZ	MENU0	; no, go menu thru a crlf
	CPI	'Y'
	JZ	DILAGN0	; yes, re-dial.
	CPI	'C'	; continuous redial?
	JNZ	DILAGN	; invalid response, ask again.
	XRA	A
	CMA
	STA	CRFLAG	; continuous redial flag
DILAGN0	MVI	B,50	; 5 seconds wait for Mark VII reset
	CALL	TIMER	; else busy tone may be sensed as dialtone
	CALL	DIALPL0	; wait for dial tone
	JNC	DIALLP1	; dial number
	JMP	MENU1	; forget it.

; telephone connection made

CONMADE	CALL	ILPRT
	DB	CR,LF,'Connection established, select options: ',BELL,0
	MVI	A,TRUE
	STA	LINEFLG	; indicate line connected
CMLP	CALL	STAT
	ORA	A
	JNZ	GETCMD	; key pressed, go get options
	MVI	A,BELL
	CALL	TYPE	; ring bell
	LXI	B,1000*MHZ	; why not?
CMLP2	DCR	C
	JNZ	CMLP2	; delay for terminal to process bell
	DCR	B
	JNZ	CMLP2	; loop for about 30 milliseconds
	JMP	CMLP	; loop 'til keypress

; initializes cp/m file control blocks at 5ch and 6ch


SETFCB	LDA	CMDBUF+1; ignore only a <return>
	ORA	A
	JZ	REENT	; try again, for proper option entry
	LXI	D,CMDBUF
	LXI	H,FCB
	CALL	CPMLINE
	CALL	PROCOPT
CHECKNM	LDA	FCB+1	; check on the primary option
	CPI	'E'	; return if echo option
	RZ
	CPI	'M'	; return to menu
	RZ
	CPI	'C'
	RZ
	CPI	'T'
	JZ	TERMSEL
	CPI	'S'
	JZ	CKFILE
	CPI	'R'
	JNZ	BDOPT
	LDA	BATCHFLG	; if mult file mode, then..
	ORA	A	; ..recv opt does not need..
	RZ		; ..name.
	JMP	CKFILE

BDOPT	CALL	ILPRT
	DB	CR,LF,'++ INVALID OPTION ++',CR,LF,BELL,0
	JMP	REENT

CKFILE	LDA	FCB+17	; if option that needs file name,..
	CPI	' '	; ..then check to see if name..
	RNZ		; ..exists. if not..
REENT	CALL	ILPRT	; ..do everything over.
	DB	CR,LF,'Reenter PRIMARY option and FILENAME only: '
	DB	BELL,0
	LXI	D,CMDBUF
	CALL	INBUFF
	JMP	SETFCB

TERMSEL	LDA	FCB+17
	CPI	' '
	JNZ	SAVAGN
	MVI	A,TRUE
	STA	NFILFLG
	CMA
	STA	ALERTFG
	STA	SAVEFLG
	RET

SAVAGN	XRA	A
	STA	NFILFLG
	RET

; crc subroutines

CLRCRC	PUSH	H	; reset crc accumulator for a new message.
	LXI	H,0
	SHLD	CRCVAL
	POP	H
	RET

UPDCRC	PUSH	PSW	; update crc accumulator usibg byte..
	PUSH	B	; ..in a-reg.
	PUSH	H
	MVI	B,8
	MOV	C,A
	LHLD	CRCVAL
UPDLOOP MOV	A,C
	RLC
	MOV	C,A
	MOV	A,L
	RAL
	MOV	L,A
	MOV	A,H
	RAL
	MOV	H,A
	JNC	SKIPIT
	MOV	A,H	; the generator is x^16 + x^12 + x^5 + 1..
	XRI	10H	; ..as recommended by ccitt.
	MOV	H,A
	MOV	A,L
	XRI	21H
	MOV	L,A
SKIPIT	DCR	B
	JNZ	UPDLOOP
	SHLD	CRCVAL
	POP	H
	POP	B
	POP	PSW
	RET

FINCRC	PUSH	PSW	; finish crc calc for outbound message.
	XRA	A
	CALL	UPDCRC
	CALL	UPDCRC
	PUSH	H
	LHLD	CRCVAL
	MOV	D,H
	MOV	E,L
	POP	H
	POP	PSW
	RET

CHKCRC	PUSH	H	; check crc bytes of received message.
	LHLD	CRCVAL
	MOV	A,H
	ORA	L
	POP	H
	RZ
	MVI	A,TRUE 
	RET

CRCVAL	DW	0

; main menu (command mode)

MENU0	CALL	CRLF	 	; used to get an extra crlf
MENU	LXI	H,RESTSN 	; restore sector numbers..
	LXI	D,SECTNOB	; ..for new file transfer.
	MVI	B,SECTNOE-SECTNOB
	CALL	MOVE
	LXI	H,RESTROPT	; restore option table
	LXI	D,OPTBL
	MVI	B,OPTBE-OPTBL
	CALL	MOVE
	XRA	A
	STA	MFFLG1	; reset mfaccess routine..
	CMA		; ..and multi trans in case..
	STA	FSTFLG	; ..of abort.
MENU1	LDA	XPRFLG	; test if menu should be shown
	ORA	A
	JNZ	XPRT
MENU2	CALL	ILPRT
	DB	CLS	; (clear screen)
	DB	ESC,'('	; bright
	DB '       -- C o m m a n d   M o d e   M e n u --',CR,LF,LF
	DB 'DIR'
	DB	ESC,')'	; dim
	DB ' - Directory roster (drive and afn''s optional)',CR,LF
	DB	ESC,'('	; bright
	DB 'RET'
	DB	ESC,')'	; dim
	DB ' - Return to Terminal Mode retaining all data',CR,LF
	DB	ESC,'('	; bright
	DB 'WRT'
	DB	ESC,')'	; dim
	DB ' - Write file to disk saved in Terminal Mode',CR,LF
	DB	ESC,'('	; bright
	DB 'DEL'
	DB	ESC,')'	; dim
	DB ' - Delete file saved in Terminal Mode',CR,LF
	DB	ESC,'('	; bright
	DB 'ERA'
	DB	ESC,')'	; dim
	DB ' - Erase CP/M files (ERA fn.ft)',CR,LF
	DB	ESC,'('	; bright
	DB 'SEL'
	DB	ESC,')'	; dim
	DB ' - Select data mode format',CR,LF
	DB	ESC,'('	; bright
	DB 'CPM'
	DB	ESC,')'	; dim
	DB ' - Exit to CP/M (telephone line connected)',CR,LF
	DB	ESC,'('	; bright
	DB 'DSC'
	DB	ESC,')'	; dim
	DB ' - Disconnect telephone line',CR,LF
	DB	ESC,'('	; bright
	DB 'CAL'
	DB	ESC,')'	; dim
	DB ' - Dial telephone number',CR,LF
	DB	ESC,'('	; bright
	DB 'T'
	DB	ESC,')'	; dim
	DB '   - Terminal Mode (T fn.ft)',CR,LF
	DB	ESC,'('	; bright
	DB 'E'
	DB	ESC,')'	; dim
	DB '   - Echo Mode (terminal)',CR,LF
	DB	ESC,'('	; bright
	DB 'S'
	DB	ESC,')'	; dim
	DB '   - Send CP/M file (S fn.ft)',CR,LF
	DB	ESC,'('	; bright
	DB 'R'
	DB	ESC,')'	; dim
	DB '   - Receive CP/M file (RT fn.ft)',CR,LF
	DB	ESC,'('	; bright
	DB 'M'
	DB	ESC,')'	; dim
	DB '   - Menu presentation',CR,LF,LF

	DB	ESC,'('	; bright
	DB '              Secondary Options:',CR,LF,LF
	DB 'T'
	DB	ESC,')'	; dim
	DB 'erminal Mode (after data transfer)',CR,LF
	DB	ESC,'('	; bright
	DB 'Q'
	DB	ESC,')'	; dim
	DB 'uiet or '
	DB	ESC,'('	; bright
	DB 'V'
	DB	ESC,')'	; dim
	DB 'iew data transfers',CR,LF
	DB	ESC,'('	; bright
	DB 'B'
	DB	ESC,')'	; dim
	DB 'atch mode (multiple file data transfers)',CR,LF
	DB	ESC,'('	; bright
	DB 0		; end of menu
	MVI	A,TRUE	; automatic transfer to xprt mode
	STA	XPRFLG
	CALL	ILPRT	; clean up display, for clarity from menu
	DB	CR,LF,0

XPRT	CALL	ILPRT
	DB	ESC,ETEOL,0	; erase-to-end-of-line
	MVI	C,INQDISK	; get default drive
	CALL	BDOS
	ADI	41H	; make ascii
	CALL	TYPE	; show on crt
	CALL	ILPRT
	DB	'>Command: ',0	; default drive prompt
GETCMD	LXI	D,CMDBUF 	; enter command
	CALL	INBUFF
	LXI	D,CMDBUF+2 	; point to command
	CALL	ILCOMP
	DB	'SEL',0
	JNC	SETDPS	; select transmission word format
	CALL	ILCOMP
	DB	'CPM',0
	JNC	PREEXIT	; leave modem, test line connection first.
	CALL	ILCOMP
	DB	'DIR',0
	JNC	DIR	; get drive directory listing
	CALL	ILCOMP
	DB	'RET',0
	JC	NXTOPT1	; carry set = no match
	LHLD	HLSAVE	; return to terminal mode with save..
	JMP	TERM	; ..option, if previously enabled.

NXTOPT1	CALL	ILCOMP	; de set from 1st ilcomp call
	DB	'DSC',0
	JNC	DISCON1
	CALL	ILCOMP
	DB	'WRT',0
	JNC	WRTFIL
	CALL	ILCOMP
	DB	'ERA',0
	JNC	ERASEF	; erase declared file(s)
	CALL	ILCOMP
	DB	'DEL',0
	JNC	NEWFILE
	CALL	ILCOMP
	DB	'CAL',0
	JC	NXTOPT2
	MVI	A,' '	; force 'procopt' routine to process 'cal' as option
	STA	CMDBUF+3
	JMP	DOOPT	; ..look at option for dial.

NXTOPT2	LDA	CMDBUF+1
	ORA	A
	JZ	MENU1	; ignore only a <return>
	LDA	CMDBUF+2
	PUSH	H
	LXI	H,COMPLIST
	CALL	COMPARE	; compares list pointed to by hl..
	POP	H	; ..to char in a-reg.
	JC	BADCMD	; carry set = no match
DOOPT	PUSH	H	; load original fcb with transfer cmds..
	CALL	SETFCB	; ..and go to beginning of program.
	POP	H	; follows same logic as if proram were..
	JMP	RESTART	; ..called with cp/m command line.

DISCON1	CALL	DISCONN
	CALL	ILPRT
	DB	CR,LF,'++ DISCONNECTED ++',CR,LF,0
	JMP	ALERT	; check for filesave, back to menu1
 
DIR	CALL	DIRLST	; from a macro in ml.lib
	JMP	XPRT	; shows command prompt, options unchanged.

NEWFILE	LDA	FCB3+1
	CPI	' '
	JZ	MENU1	; if no file, don't erase
	LXI	D,FCB3
	MVI	C,ERASE
	CALL	BDOSRET
	MVI	A,TRUE	; save not allowed since filename deleted
	STA	NFILFLG
	CMA
	STA	ALERTFG
	STA	SAVEFLG
	LXI	H,FCB3
	CALL	INITFCBS
	JMP	MENU1	; back thru xprt to command mode prompt

WRTFIL	LDA	NFILFLG
	CPI	TRUE
	JZ	MENU1
	LDA	FCB3+1	; check that file was requested
	CPI	' '
	JZ	MENU1
	LHLD	HLSAVE
	CALL	NUMRECS
	CALL	WRTDSK	; in intdsksv routine
	CALL	CLOSE3
	MVI	A,TRUE
	STA	NFILFLG
	CMA
	STA	ALERTFG
	STA	SAVEFLG
	LXI	H,FCB3
	CALL	INITFCBS; blank out fcb so written file..
	JMP	MENU1	; ..can't be erased.

ERASEF	LXI	D,CMDBUF	; put cmd line into fcb at hl
	LXI	H,FCB
	CALL	CPMLINE
	CALL	MOVEFCB	; move fcb+16 to fcb
	LDA	FCB+1
	CPI	' '
	JZ	BADCMD	; redo
	LXI	D,FCB
	MVI	C,SRCHF
	CALL	BDOS
	INR	A	;  0ffh -> 0 means file not found.
	JNZ	ERAFILE	; this is why we're here, do it.
BADCMD	CALL	ILPRT
	DB	CR,LF,'++ FILE NOT FOUND -- RE-ENTER COMMAND ++',CR,LF,BELL,0
	JMP	MENU1

ERAFILE LXI	D,FCB
	MVI	C,ERASE
	CALL	BDOS
	JMP	MENU1

XPRMODE	LDA	XPRFLG
	CMA
	STA	XPRFLG
	JMP	MENU1

COMPARE	MOV	B,M	; compares a-reg with list..
COMPLP	INX	H	; ..addressed by hl.  first element..
	CMP	M	; ..of list must be number of elements..
	RZ		; ..being compared.  returns with..
	DCR	B	; ..carry set if a-reg does not..
	JNZ	COMPLP	; ..contain an element in list.
	STC
	RET

COMPLIST DB 5, 'S', 'R', 'T', 'E', 'M'	; address in hl-reg

SETDPS	CALL	ILPRT
	DB	CLS,LF,LF,LF,LF,LF
	DB	LF,'             Select Data Mode Format:',CR,LF,LF
	DB	HT,'      data     parity     stop',CR,LF
	DB	HT,'      ----     ------     ----',CR,LF
	DB	HT,'  1 -  8        odd        1',CR,LF
	DB	HT,'  2 -  8        even       1',CR,LF
	DB	HT,'  3 -  8        none       1 (default)',CR,LF
	DB	HT,'  4 -  8        none       2',CR,LF
	DB	HT,'  5 -  7        odd        1',CR,LF
	DB	HT,'  6 -  7        even       1',CR,LF
	DB	HT,'  7 -  7        odd        2',CR,LF
	DB	HT,'  8 -  7        even       2',CR,LF,LF,0
AGAIN	CALL	ILPRT
	DB	CR,'             Enter choice (1 - 8): ',0
	CALL	KEYIN
	CALL	UCASE
	CALL	TYPE
	CPI	'1'
	JZ	DPS1
	CPI	'2'
	JZ	DPS2
	CPI	'3'
	JZ	DPS3
	CPI	'4'
	JZ	DPS4
	CPI	'5'
	JZ	DPS5
	CPI	'6'
	JZ	DPS6
	CPI	'7'
	JZ	DPS7
	CPI	'8'
	JZ	DPS8
	JMP	AGAIN

DPS1	MVI	A,1CH
	JMP	DPSXIT

DPS2	MVI	A,18H
	JMP	DPSXIT

DPS3	MVI	A,14H
	JMP	DPSXIT

DPS4	MVI	A,10H
	JMP	DPSXIT

DPS5	MVI	A,0CH
	JMP	DPSXIT

DPS6	MVI	A,08H
	JMP	DPSXIT

DPS7	MVI	A,04H
	JMP	DPSXIT

DPS8	MVI	A,00H
DPSXIT	STA	MODE
	JMP	START3


BADOPT	CALL	ILPRT
	DB	CR,LF,'++ INVALID OPTION ++',CR,LF,BELL,0
	JMP	MENU	; reset option table, show command prompt.


; macros in ml.lib

ILCOMP	INLNCOMP
INBUFF	INBUF
CPMLINE	CMDLINE
DIRLST	DIRLIST

; table storage

OPTBL	EQU $
DISCFLG	DB 'D'	; disconnect after primary mode complete
QFLG	DB 'Q'	; suppress all transmission text from crt terminal
RSEEFLG	DB 'R'	; view receive ascii text on crt
SSEEFLG	DB 'S'	; view send ascii text on crt
VSEEFLG	DB 'V'	; view either send or receive text
TERMFLG	DB 'T'	; return to terminal mode after transfer
BATCHFLG DS 1	; set to 'b' at menu.  doesn't allow multi-..
OPTBE	EQU $	; ..file xfer when program initially called.

RESTROPT	; restore option table, order same as table above.
	DB 'D','Q','R','S','V','T','B'

RESTSN	DB 0,0,0,0,0,0
	DW DBUF
	DB 0,0,0,0,0,0

SECTNOB	EQU $
RCVSNO	DB 0
SECTNO	DW 0
ERRCT	DB 0
ERRCDE	DB 0
EOFLG	DB 0
SECPTR	DW DBUF
SECINBF	DB 0
MAXEXT	DB 0
RCNT	DW 0
DATAFLG	DB 0
EXACFL	DB 0
SECTNOE	EQU $

; other initialized storage

OPTION	DB	0	; active table options set to zero
CRFLAG	DB	0	; continuous redial flag
CRCFLG	DB 	'C'	; use crc instead of cksum
LNEDFLG	DB 	TRUE	; normally set default true
FSTFLG	DB	TRUE	; 1st time thru batch
FIRSTME	DB	TRUE	; false after 1st soh received
MODCTLB	DB	7FH
UARTFLG DB	TRUE	; uart control initializied as answer mode..
UARTCTL DB	INITC2	; 8 data bits, no parity, 1 stop bit
MODE	DB	14H	; 8 data bits, no parity, 1 stop bit
NFILFLG	DB	TRUE	; false allows write to memory in 't' mode
ALERTFG DB	FALSE	; true announces file-save was established
LINEFLG	DB	FALSE	; true shows telephone line connected
CMDBUF	DB	80H,0	; cp/m default buffer address and..

; uninitialized storage

	DS	80H	; ..storage space.
HLSAVE	DS	2
DISKNO	DS	1
SENDFLG	DS	1
NBSAVE	DS	2
BGNMS	DS	2
FILECT	DS	1
NAMECT	DS	1
	DS	100	; local stack starts here for 50 levels
STACK	DS	2	; cp/m stack pointer saved here
FCB3	DS	33
FCB4	DS	33
FCBBUF	DS	15
;
source	equ	$	; boundry memory marker
;
offset	equ	dest-source	; relocation amount to move
;
start	equ	$+offset	; start of executable (relocated code)
;
; modem I/O
;
outdata	equ	$+offset
;
	di		; disable interrupts
	out	0
	sta	mddatp
	out	1
	ei		; enable interrupts
	ret

indata	equ	$+offset
;
	di		; disable interrupts
	out	0
	lda	mddatp
	out	1
	ei		; enable interrupts
	ret
;
outctl	equ	$+offset
;
	di		; disable interrupts
	out	0
	sta	mdctlp
	out	1
	ei		; enable interrupts
	ret

inctl	equ	$+offset
;
	di		; disable interrupts
	out	0
	lda	mdctlp
	out	1
	ei		; enable interrupts
	ret

DBUF	EQU	$+offset	
NAMEBUF	EQU	DBUF+(DBUFSIZ*1024)	; batch mode names buffer..

LAST	EQU	$+offset

; a set for pointer to file-save storage

BOTTRAM	EQU	LAST+80H AND 0FF80H

pend	equ	$+offset	; end of relocated modem i/o

	END
